export declare const id: (x: any) => any;
export declare type OpticType = 'Equivalence' | 'Iso' | 'Lens' | 'Prism' | 'Traversal' | 'Getter' | 'AffineFold' | 'Fold' | 'Setter';
declare type CompositionType = {
    [T in OpticType]: {
        [U in OpticType]: OpticType | undefined;
    };
};
export declare const compositionType: CompositionType;
declare type Profunctor = any;
interface OpticFn {
    _tag: OpticType;
    _removable?: true | undefined;
    (P: Profunctor, optic: OpticFn): any;
}
export declare const modify: (optic: any, fn: (x: any) => any, source: any) => any;
export declare const set: (optic: any, value: any, source: any) => any;
export declare const remove: (optic: any, source: any) => any;
export declare const get: (optic: any, source: any) => any;
export declare const preview: (optic: any, source: any) => any;
export declare const collect: (optic: any, source: any) => any;
export declare class Optic {
    _ref: OpticFn;
    constructor(_ref: OpticFn);
    get _tag(): OpticType;
    get _removable(): true | undefined;
    compose(other: Optic): Optic;
    iso(there: (x: any) => any, back: (x: any) => any): Optic;
    prop(key: string): Optic;
    path(keys: string[]): Optic;
    pick(keys: string[]): Optic;
    filter(predicate: (item: any) => boolean): Optic;
    valueOr(defaultValue: any): Optic;
    optional(): Optic;
    guard_(): (fn: Function) => Optic;
    guard(fn: Function): Optic;
    at(i: number): Optic;
    head(): Optic;
    index(i: number): Optic;
    find(predicate: (item: any) => boolean): Optic;
    elems(): Optic;
    to(fn: (a: any) => any): Optic;
    when(predicate: (elem: any) => boolean): Optic;
    chars(): Optic;
    words(): Optic;
    prependTo(): Optic;
    appendTo(): Optic;
}
export declare const optic: Optic;
export {};
