interface NotAnArrayType<_T> {
    readonly _: unique symbol;
}
export declare type ElemType<A> = IfElse<IsOptional<A>, NotAnArrayType<A>, A extends (infer Item)[] ? Item : NotAnArrayType<A>>;
export declare type Eq<A, B> = (() => A) extends () => B ? (() => B) extends () => A ? true : false : false;
export declare type Simplify<A, B> = Eq<A, B> extends true ? A : B;
export declare type IsOptional<A> = Or<ExtendsUndefined<A>, ExtendsNull<A>>;
declare type ExtendsUndefined<A> = Eq<A | undefined, A>;
declare type ExtendsNull<A> = Eq<A | null, A>;
declare type Or<A extends true | false, B extends true | false> = A extends true ? true : B;
export declare type IfElse<Condition extends true | false, Then, Else> = Condition extends true ? Then : Else;
export declare type RequireString<A, B> = IfElse<Eq<A, string>, B, ExpectedStringButGot<A>>;
interface ExpectedStringButGot<_T> {
    readonly _: unique symbol;
}
export {};
